/* Author:   $Author: jan $
 * File:     $Source: /usr/usrs/jan/desktop/X_Book.boo/programs/RCS/realform.c,v $
 * Date:     $Date: 1992/09/09 00:10:07 $
 * Revision: $Revision: 1.1 $
 */

#include "copyright.h"

#include <stdio.h> 
 
#include <X11/Intrinsic.h> 
#include <Xm/Xm.h> 
#include <Xm/Label.h>
#include <Xm/Text.h> 
#include <Xm/Form.h> 
 
/*------------------------------------------------------------- 
**	 Forward Declarations 
*/ 
 
void main ();			/*  main logic for application	*/ 
 
void CreateApplication ();	/*  create main window		*/ 
void QuitCB ();			/*  callback for quit button	*/ 
 
/*------------------------------------------------------------- 
**	Global Variables 
*/ 
 
#define MAX_ARGS 20 
#define Class_name "FourButtons" 
 
static XmStringCharSet	charset = (XmStringCharSet) XmSTRING_DEFAULT_CHARSET; 
/*------------------------------------------------------------- 
**	main		- main logic for application 
*/ 
void main (argc,argv)  
	unsigned int	argc; 
	 char 		**argv; 
{ 
	 Widget		app_shell;	/*  ApplicationShell	*/ 
 
	 /*	Initialize toolkit, open the display and create the toplevel widget. */ 
	 app_shell = XtInitialize(argv[0], /* application name */	
	 	 	 Class_name, 	/* class name */	
	 	 	 NULL, 		/* options */	
	 	 	 0,		/* number of options */	
	 	 	 &argc, argv);	
  
	 /* set up all the sub-widgets */ 
	 CreateApplication(app_shell);
	 XtRealizeWidget (app_shell); 
 
	 /*	Get and dispatch events. 
	 */ 
	 XtMainLoop (); 
} 
 
/*------------------------------------------------------------- 
**	 CreateApplication	- create main window 
**	 	 This must be customised for each application.
*/ 
void CreateApplication (parent)  
Widget		parent;		/*  parent widget	*/ 
{ 
	Widget		form;	/*  Form		*/ 
	Widget		label[3], text[3];
 
	 Arg		args[MAX_ARGS];	/*  arg list		*/ 
	 register int	n;		/*  arg count		*/ 
 
	 /*	Create Form Window. 
	 */ 
	 n = 0; 
	 form = XmCreateForm (parent, "aForm", args, n);	
	 XtManageChild (form); 	

	 n = 0; 
	 label[0] = XmCreateLabel (form, "Name", args, n); 
 	
	 n = 0; 
	 label[1] = XmCreateLabel (form, "Address", args, n); 
 
	 n = 0; 
	 label[2] = XmCreateLabel (form, "Telephone", args, n); 
 
	 n = 0; 
	 text[0] = XmCreateText (form, "Widget 4", args, n); 
	 n = 0; 
	 text[1] = XmCreateText (form, "Widget 4", args, n); 
	 n = 0; 
	 text[2] = XmCreateText (form, "Widget 4", args, n); 

        /* geometry for label 2
        */
        n = 0;
        XtSetArg (args[n], XmNalignment, XmALIGNMENT_END); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNtopPosition, 66); n++;
        XtSetValues (label[2], args, n);

        /* geometry for label 1
        */
        n = 0;
        XtSetArg (args[n], XmNalignment, XmALIGNMENT_END); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNbottomPosition, 66); n++;
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNtopPosition, 33); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
        XtSetArg (args[n], XmNrightWidget, label[2]); n++;
        XtSetValues (label[1], args, n);

        /* geometry for label 0
        */
        n = 0;
        XtSetArg (args[n], XmNalignment, XmALIGNMENT_END); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNbottomPosition, 33); n++;
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
        XtSetArg (args[n], XmNrightWidget, label[1]); n++;
        XtSetValues (label[0], args, n);

        /* geometry for text 0
        */
        n = 0;
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNbottomPosition, 33); n++;
        XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
        XtSetArg (args[n], XmNleftWidget, label[0]); n++;
        XtSetValues (text[0], args, n);

        /* geometry for text 1
        */
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNtopPosition, 33); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNbottomPosition, 66); n++;
        XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
        XtSetArg (args[n], XmNleftWidget, label[1]); n++;
        XtSetValues (text[1], args, n);

        /* geometry for text 2
        */
        XtSetArg (args[n], XmNtopAttachment, XmATTACH_POSITION); n++;
        XtSetArg (args[n], XmNtopPosition, 66); n++;
        XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
        XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
        XtSetArg (args[n], XmNleftWidget, label[2]); n++;
        XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
        XtSetValues (text[2], args, n);
	 XtManageChild (label[0]); 
	 XtManageChild (label[1]); 
	 XtManageChild (label[2]); 
	 XtManageChild (text[0]);	
	 XtManageChild (text[1]);	
	 XtManageChild (text[2]);	
} 
 
/*------------------------------------------------------------- 
**	 QuitCB			- callback for quit button 
*/ 
void QuitCB (w, client_data, call_data)  
Widget		w;		/*  widget id		*/ 
caddr_t		client_data;	/*  data from application   */ 
caddr_t		call_data;	/*  data from widget class  */ 
{ 
 
	 /*	Terminate the application. 
	 */ 
	 printf("button was pressed\n");
	 exit (0); 
} 
